Summary: smtp server for firewall
Name: obtuse-smtpd
Version: 2.0
Release: 4
Copyright: BSD-style
Group: Networking/Daemons
URL: http://www.obtuse.com/smtpd.html
Source: ftp://ftp.obtuse.com/pub/smtpd/smtpd-2.0.tar.gz
Source1: smtpfwdd.init
Source2: smtpd_check_rules
Patch0: smtpd-2.0-patch
Patch1: ftp://ftp.obtuse.com/pub/smtpd/patch-smtpd-2.0-RBL.gz
Packager: Brian Candler <B.Candler@pobox.com>
BuildRoot: /tmp/smtpd-root

%description
This is the Obtuse smtpd/smtpfwdd SMTP store and forward
proxy. It can be used to pass SMTP mail across a dual-homed bastion host
(such as in a firewall) with minimal danger.  It can also be used if
you simply don't want your big complicated mail agent (such as sendmail)
establishing direct contact with the outside world. It is useful for
people who wish to practice "Safe Sendmail" :-)

You will want to check /var/spool/smtpd/etc/smtpd_check_rules after
installation; you will also need to reboot (or restart sendmail,
HUP inetd, and start smtpfwdd, in that order)

%changelog
* Sat Jun 06 1998 Brian Candler <B.Candler@pobox.com>
  - Sigh, ctime() doesn't produce RFC-conformant date strings.
    localtime file moved to [chroot]/usr/lib/zoneinfo/

* Sat Jun 06 1998 Brian Candler <B.Candler@pobox.com>
  - Received: line now complies with draft-ietf-drums-smtpupd-07.txt

* Fri Jun 05 1998 Brian Candler <B.Candler@pobox.com>
  - First release. Tries to be reasonably intelligent about inetd.conf,
    smtpd_check_rules, and sendmail.init.

%prep
%setup -n smtpd-$RPM_PACKAGE_VERSION
%patch -p1
%patch1

%build
make RPM_OPT_FLAGS="$RPM_OPT_FLAGS"

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/usr/sbin
make install

mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
install -m 755 -o root -g root $RPM_SOURCE_DIR/smtpfwdd.init $RPM_BUILD_ROOT/etc/rc.d/init.d/smtpfwdd
for i in 2 3 5; do
  mkdir $RPM_BUILD_ROOT/etc/rc.d/rc$i.d
  ln -s ../init.d/smtpfwdd $RPM_BUILD_ROOT/etc/rc.d/rc$i.d/S81smtpfwdd
done
for i in 0 1 6; do
  mkdir $RPM_BUILD_ROOT/etc/rc.d/rc$i.d
  ln -s ../init.d/smtpfwdd $RPM_BUILD_ROOT/etc/rc.d/rc$i.d/K29smtpfwdd
done

mkdir -p $RPM_BUILD_ROOT/var/spool/smtpd/etc
mkdir -p $RPM_BUILD_ROOT/var/spool/smtpd/usr/lib/zoneinfo
chown uucp:uucp $RPM_BUILD_ROOT/var/spool/smtpd
chmod 700 $RPM_BUILD_ROOT/var/spool/smtpd

install -m 644 -o root -g root $RPM_SOURCE_DIR/smtpd_check_rules $RPM_BUILD_ROOT/var/spool/smtpd/etc/smtpd_check_rules

# Not sure we have permission to distribute these, so...
cat <<END >README.man
For man pages please see:
http://www.obtuse.com/juniper-docs/man/smtpd.html
http://www.obtuse.com/juniper-docs/man/smtpfwdd.html
http://www.obtuse.com/juniper-docs/man/smtpd_address_check.html
END

%clean
rm -rf $RPM_BUILD_ROOT

%post
# smtpd needs these files in its chroot 'jail'
[ ! -f /var/spool/smtpd/etc/resolv.conf ] && cp -p /etc/resolv.conf /var/spool/smtpd/etc/resolv.conf
[ ! -f /var/spool/smtpd/usr/lib/zoneinfo/localtime ] && cp -p /etc/localtime /var/spool/smtpd/usr/lib/zoneinfo/localtime

# update inetd.conf to run smtpd
{
  # Anybody know a nicer way of getting sed to match 'space or tab' ?
  sed 's/^smtp[ 	]/#smtp /' /etc/inetd.conf
  echo "smtp stream tcp nowait root /usr/sbin/tcpd smtpd"
} >/etc/inetd.conf.new && mv /etc/inetd.conf.new /etc/inetd.conf

# make a stab at suitable anti-relay config
(
  cd /var/spool/smtpd/etc
  if [ -f smtpd_check_rules.rpmorig ]; then
    cp -p smtpd_check_rules{.rpmorig,}
  elif [ -f smtpd_check_rules.rpmsave ]; then
    cp -p smtpd_check_rules{.rpmsave,}
  else
    # First: patch my.domain to what we think our domain probably is
    DOM=$(uname -n | sed 's/^[^.]*\.//')
    sed "s/my\\.domain/$DOM/g" smtpd_check_rules > smtpd_check_rules.new &&
    mv smtpd_check_rules{.new,}

    # Next: process /etc/sendmail.cw if it exists
    set -f  # stop expansion of '*' patterns
    MOREDOMS=$(echo $(
        sed "/^#/d;/^$DOM\$/d;/\\.$DOM\$/d;s/^/*@/" /etc/sendmail.cw /etc/mail/sendmail.cw 2>/dev/null
    ))
    set +f
    if [ "$MOREDOMS" != "" ]; then
      sed "/^allow:ALL:ALL:\\*\\./s/\$/ $MOREDOMS/" smtpd_check_rules >smtpd_check_rules.new &&
      mv smtpd_check_rules{.new,}
    fi
  fi
)

# Patch up the sendmail/sendmail.init file
PATCHME=/etc/rc.d/init.d/sendmail
if [ ! -f $PATCHME ]; then
  PATCHME=$PATCHME.init
  if [ ! -f $PATCHME ]; then
    PATCHME=""
  fi
fi

# Note: this assumes there is both -bd and -qXX on the command line. If
# there is only -bd, then it doesn't work at boot time...
if [ "$PATCHME" != "" ]; then
  sed '/daemon /s/ -bd//' $PATCHME >$PATCHME.new &&
  mv $PATCHME.new $PATCHME &&
  chmod 755 $PATCHME
fi

%postun
# Try and undo everything above
sed '/^smtp.*smtpd/d' /etc/inetd.conf >/etc/inetd.conf.new &&
mv /etc/inetd.conf.new /etc/inetd.conf

PATCHME=/etc/rc.d/init.d/sendmail
if [ ! -f $PATCHME ]; then
  PATCHME=$PATCHME.init
  if [ ! -f $PATCHME ]; then
    PATCHME=""
  fi
fi

if [ "$PATCHME" != "" ]; then
  sed '/daemon /s/sendmail/sendmail -bd/' $PATCHME >$PATCHME.new &&
  mv $PATCHME.new $PATCHME &&
  chmod 755 $PATCHME
fi

%files
%dir /var/spool/smtpd
%dir /var/spool/smtpd/usr/lib/zoneinfo
%config /var/spool/smtpd/etc/smtpd_check_rules
%doc CREDITS INSTALL LICENSE README README.man
%doc antirelay_check_rules_example
%doc antispam_check_rules.example
%doc smtpd_check_rules.example
/etc
/usr/sbin
#/usr/man  # none in this package
